/* ******** netUstad: Network Ustadi (Network Master) ******** */
/* This software is Copyright (C) 2004 by Ozkan KIRIK.        */
/* Permission is granted to redistribute and modify this      */
/* software under the terms of the GNU General Public License */
/* available at http://www.gnu.org/                           */
/**************************************************************/

#include "deleterule.h"
#include "netustad.h"
#include "loadconfig.h"

/***************************************************************/
/* Deleting An IPFW Rule                                       */
/***************************************************************/
void 
deleterule(int client, const char *path, const char *parameters,
	   const char *method, const char *query_string)
{
	FILE           *resource = NULL;
	char		buf       [1024];
	char		log_string[512];
	int		cgi_output [2];
	int		cgi_input  [2];
	pid_t		pid;
	int		status;

	/* char c; */
	int		numchars = 1;

	buf[0] = 'A';
	buf[1] = '\0';
	if (strcasecmp(method, "GET") == 0)
		while ((numchars > 0) && strcmp("\n", buf))	/* read & discard
								 * headers */
			numchars = get_line(client, buf, sizeof(buf));
	else {			/* POST */
		unimplemented(client);
		return;
	}

	if (strlen(query_string) != 5) {
		unimplemented(client);
		return;
	}
	snprintf(buf, sizeof(buf), "HTTP/1.0 200 OK\r\nContent-Type: text/html\n\n");
	send(client, buf, strlen(buf), 0);

	if (pipe(cgi_output) < 0) {
		cannot_execute(client);
		return;
	}
	if (pipe(cgi_input) < 0) {
		cannot_execute(client);
		return;
	}
	if ((pid = fork()) < 0) {
		cannot_execute(client);
		return;
	}
	if (pid == 0) {		/* child: Delete rule */
		dup2(cgi_output[1], 1);
		dup2(cgi_input[0], 0);
		close(cgi_output[0]);
		close(cgi_input[1]);


		execl(path, path, parameters, query_string, NULL);

		exit(0);
	} else {		/* parent */
		close(cgi_output[1]);
		close(cgi_input[0]);

		snprintf(buf, sizeof(buf), "<html><head><meta http-equiv='Refresh' content='2; URL=/$%s'>\n\
	<meta http-equiv='Pragma' content='no-cache'>\n\
        <title>netUstad</title></head><style>\n", server_sid);
		send(client, buf, strlen(buf), 0);
		resource = fopen("script/netustad.css", "r");
		cat(client, resource);
		fclose(resource);
		time(&currentsec);
		timenow = strtok(ctime(&currentsec), "\n");
		snprintf(log_string, sizeof(log_string), "%s -- IP: %s Delete Rule: %s\n", \
			 (char *)timenow, \
			 (char *)inet_ntoa(client_name.sin_addr), \
			 (char *)query_string);
		log_msg(logfile, log_string);

		snprintf(buf, sizeof(buf), "</style>\n<body><center>\n<br><b>Rule %s is deleted<b><br>Redirecting to Rule List</body></html>", query_string);
		send(client, buf, strlen(buf), 0);
		close(cgi_output[0]);
		close(cgi_input[1]);

		waitpid(pid, &status, 0);
	}
}
